//+------------------------------------------------------------------+
//|                                       JurikVolty_Normal_v1.1.mq4 |
//|                                Copyright  2010, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
// List of Prices:
// Price    = 0 - Close  
// Price    = 1 - Open  
// Price    = 2 - High  
// Price    = 3 - Low  
// Price    = 4 - Median Price   = (High+Low)/2  
// Price    = 5 - Typical Price  = (High+Low+Close)/3  
// Price    = 6 - Weighted Close = (High+Low+Close*2)/4
// Price    = 7 - Heiken Ashi Close  
// Price    = 8 - Heiken Ashi Open
// Price    = 9 - Heiken Ashi High
// Price    =10 - Heiken Ashi Low
 
#property copyright "Copyright  2010, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  SkyBlue
#property indicator_width1  1
#property indicator_color2  Tomato
#property indicator_style2  2

//---- 
extern int     TimeFrame         =   0;   //Time Frame in min
extern int     Price             =   0;   //Price Mode (0...10)
extern int     Length            =  14;   //Period of smoothing
extern int     Signal            =   5;   //Period of Signal SMA
extern int     Window            = 100;   //Period of Normalizing    
extern int     VisualMode        =   0;   //0-Volty,1-incremental sum of (Volty - Volty[10])/10

//---- 
double JVolty[];
double sig[];
//----
double haClose[], haOpen[], haHigh[], haLow[];
int    draw_begin, pBars, mcnt_bars; 
string short_name;
datetime pTime;
bool   UpTrendAlert=false, DnTrendAlert=false;
double len, len1, len2, pow1, bet, R;
int    AvgLen = 65;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//---- 
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
  
   if(TimeFrame == 0 || TimeFrame < Period()) TimeFrame = Period();
     
   draw_begin=AvgLen*TimeFrame/Period();
//---- 
   switch(TimeFrame)
   {
   case 1     : string TF = "M1"; break;
   case 5     : TF = "M5"; break;
   case 15    : TF = "M15"; break;
   case 30    : TF = "M30"; break;
   case 60    : TF = "H1"; break;
   case 240   : TF = "H4"; break;
   case 1440  : TF = "D1"; break;
   case 10080 : TF = "W1"; break;
   case 43200 : TF = "MN1"; break;
   default    : TF = "Current";
   } 
   short_name = "JurikVolty Normal";
   IndicatorShortName(short_name+"("+Price+","+Length+","+Signal+","+Window+")"+" "+TF);
   SetIndexLabel(0,short_name);
   SetIndexLabel(1,"Signal");
   
   SetIndexDrawBegin(0,draw_begin);
   SetIndexDrawBegin(1,draw_begin);
//---- 
   SetIndexBuffer(0,JVolty);
   SetIndexBuffer(1,sig);
//----
   len = 0.5*(Length - 1);
   
   len1 = MathLog(MathSqrt(len))/MathLog(2.0) + 2;
	if (len1 < 0) len1 = 0;
 	
	pow1 = len1 - 2;
	if (pow1 < 0.5) pow1 = 0.5;
    
	len2 = MathSqrt(len)*len1;
    
	bet = len2/(len2 + 1);   
//---- 
   return(0);
}
//+------------------------------------------------------------------+
//| JurikVolty_Normal_v1.1                                           |
//+------------------------------------------------------------------+
int start()
{
   int limit, y, i, shift, cnt_bars=IndicatorCounted(); 
   double price, bsmax[], bsmin[], Volty[], AvgVolty[], nVolty[], SigVolty[], vSum[];
      
   if(TimeFrame!=Period()) int mBars = iBars(NULL,TimeFrame); else mBars = Bars; 
   if(mBars != pBars)
   {
   ArrayResize(bsmin,mBars);
   ArrayResize(bsmax,mBars);
   ArrayResize(AvgVolty,mBars);
   ArrayResize(Volty,mBars); 
   ArrayResize(vSum,mBars);
   ArrayResize(nVolty,mBars);
   ArrayResize(SigVolty,mBars);    
      if(Price > 6 && Price <= 10)
      {
      ArrayResize(haClose,mBars);
      ArrayResize(haOpen,mBars);
      ArrayResize(haHigh,mBars);
      ArrayResize(haLow,mBars);
      }
  
   pBars = mBars;
   }  
   
   if(cnt_bars<1)
   {
      for(i=Bars-1;i>0;i--) 
      {
      JVolty[i]=EMPTY_VALUE; 
      sig[i]=EMPTY_VALUE;
      }
   mcnt_bars = 0;
   }
//---- 
   if(mcnt_bars > 0) mcnt_bars--;
   
   for(y=mcnt_bars;y<mBars;y++)
   {
   if(Price <= 6) price = iMA(NULL,TimeFrame,1,0,0,Price,mBars-y-1);   
   else
   if(Price > 6 && Price <= 10) price = HeikenAshi(TimeFrame,Price-7,mBars-y-1);
   
      if(y == 1) {bsmax[y] = price; bsmin[y] = price;}
      else
      {  
	 	double del1 = price - bsmax[y-1];
      double del2 = price - bsmin[y-1];
		
      if(MathAbs(del1) > MathAbs(del2)) Volty[y] = MathAbs(del1); 
      else 
	   if(MathAbs(del1) < MathAbs(del2)) Volty[y] = MathAbs(del2);
	   else
	   if(MathAbs(del1) == MathAbs(del2)) Volty[y] = 0;
		
	   
	   vSum[y] = vSum[y-1] + 0.1*(Volty[y] - Volty[y-10]);
	   if(y <= AvgLen+1) AvgVolty[y] = AvgVolty[y-1] + 2.0*(vSum[y] - AvgVolty[y-1])/(AvgLen+1);	    
		else
		AvgVolty[y] = SMA(vSum,AvgLen,y);
	         
      if (AvgVolty[y] > 0) double dVolty = Volty[y]/AvgVolty[y];
	   if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
      if (dVolty < 1) dVolty = 1.0;
	   
	   double pow2 = MathPow(dVolty, pow1);
      double Kv = MathPow(bet, MathSqrt(pow2));		
      	     
      if (del1 > 0) bsmax[y] = price; else bsmax[y] = price - Kv*del1;
      if (del2 < 0) bsmin[y] = price; else bsmin[y] = price - Kv*del2;
      	   
      double vmax = 0;
      double vmin = 10000000;
         for(i=Window;i>=0;i--)
         { 
         if(VisualMode == 0) double volty = Volty[y-i]; else volty = vSum[y-i]; 
         vmax = MathMax(vmax,volty);
         vmin = MathMin(vmin,volty); 
         }   
      
      if(vmax-vmin != 0) nVolty[y] = 100*(volty - vmin)/(vmax - vmin); else nVolty[y] = 0;  
      
      if(y <= Signal+1) SigVolty[y] = SigVolty[y-1] + 2.0*(nVolty[y] - SigVolty[y-1])/(Signal+1);	    
		else
		SigVolty[y] = SMA(nVolty,Signal,y);
		    
         if(TimeFrame == Period()) 
         {
         JVolty[mBars-y-1] = nVolty[y];
         sig[mBars-y-1] = SigVolty[y]; 
         }            
      }
   mcnt_bars = mBars-1;
   }
   
   if(TimeFrame > Period())
   { 
      if(cnt_bars>0) cnt_bars--;
      limit = Bars-cnt_bars+TimeFrame/Period()-1;
      
      for(shift=0,y=0;shift<limit;shift++)
      {
      if (Time[shift] < iTime(NULL,TimeFrame,y)) y++; 
         
      JVolty[shift] = nVolty[mBars-y-1];
      sig[shift] = SigVolty[mBars-y-1];
      }
   }
   return(0);
}

double SMA(double array[],int per,int bar)
{
   double Sum = 0;
   for(int i = 0;i < per;i++) Sum += array[bar-i];
   
   return(Sum/per);
}                

double HeikenAshi(int tf,int price,int bar)
{ 
   if(bar == iBars(NULL,TimeFrame)- 1) 
   {
   haClose[bar] = iClose(NULL,tf,bar);
   haOpen[bar]  = iOpen(NULL,tf,bar);
   haHigh[bar]  = iHigh(NULL,tf,bar);
   haLow[bar]   = iLow(NULL,tf,bar);
   }
   else
   {
   haClose[bar] = (iOpen(NULL,tf,bar)+iHigh(NULL,tf,bar)+iLow(NULL,tf,bar)+iClose(NULL,tf,bar))/4;
   haOpen[bar]  = (haOpen[bar+1]+haClose[bar+1])/2;
   haHigh[bar]  = MathMax(iHigh(NULL,tf,bar),MathMax(haOpen[bar], haClose[bar]));
   haLow[bar]   = MathMin(iLow(NULL,tf,bar),MathMin(haOpen[bar], haClose[bar]));
   }
   
   switch(price)
   {
   case 0: return(haClose[bar]);break;
   case 1: return(haOpen[bar]);break;
   case 2: return(haHigh[bar]);break;
   case 3: return(haLow[bar]);break;
   }
}     

